#!/usr/bin/python
#
# check_remote_host.py -- nagios plugin uses check_nrpe to check the host
#                         status
#
# Copyright (C) 2014 Red Hat Inc
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,USA
#

import argparse
import sys

import server_utils
from glusternagios import utils


# Main method
if __name__ == "__main__":
    parser = argparse.ArgumentParser(description="Check Host Status Tool")
    parser.add_argument('-H', '--hostip', action='store', dest='hostip',
                        type=str, required=True, help='Host IP')
    args = parser.parse_args()

    # Check if the NRPE call goes through to the host
    rc, out, err = utils.execCmd(
        [
            server_utils.nrpeCmdPath.cmd,
            '-H',
            args.hostip
        ]
    )

    if rc == utils.PluginStatusCode.OK:
        print "OK: Host is UP"
        sys.exit(utils.PluginStatusCode.OK)
    else:
        print "CRITICAL: NRPE service on the host is down or not responding"
        sys.exit(utils.PluginStatusCode.CRITICAL)
